Magisk/scripts/util_functions.sh

421 lines
11 KiB
Bash
Raw Normal View History

2017-06-18 18:15:44 +02:00
##########################################################################################
#
2017-06-18 18:15:44 +02:00
# Magisk General Utility Functions
# by topjohnwu
#
2017-09-13 09:44:35 +02:00
# Used everywhere in Magisk
#
2017-06-18 18:15:44 +02:00
##########################################################################################
2019-02-11 23:14:07 +01:00
###################
# Helper Functions
###################
2017-07-10 19:54:11 +02:00
2019-02-11 23:14:07 +01:00
ui_print() {
$BOOTMODE && echo "$1" || echo -e "ui_print $1\nui_print" >> /proc/self/fd/$OUTFD
}
2018-01-01 09:46:28 +01:00
2019-02-11 23:14:07 +01:00
toupper() {
echo "$@" | tr '[:lower:]' '[:upper:]'
}
2019-02-11 23:14:07 +01:00
grep_cmdline() {
local REGEX="s/^$1=//p"
cat /proc/cmdline | tr '[:space:]' '\n' | sed -n "$REGEX" 2>/dev/null
}
grep_prop() {
local REGEX="s/^$1=//p"
shift
local FILES=$@
[ -z "$FILES" ] && FILES='/system/build.prop'
sed -n "$REGEX" $FILES 2>/dev/null | head -n 1
}
getvar() {
local VARNAME=$1
local VALUE=
VALUE=`grep_prop $VARNAME /sbin/.magisk/config /data/.magisk /cache/.magisk`
[ ! -z $VALUE ] && eval $VARNAME=\$VALUE
}
is_mounted() {
grep -q " `readlink -f $1` " /proc/mounts 2>/dev/null
return $?
}
abort() {
ui_print "$1"
$BOOTMODE || recovery_cleanup
exit 1
}
resolve_vars() {
MAGISKBIN=$NVBASE/magisk
POSTFSDATAD=$NVBASE/post-fs-data.d
SERVICED=$NVBASE/service.d
2019-02-11 23:14:07 +01:00
}
######################
# Environment Related
######################
2017-10-31 10:05:24 +01:00
2018-08-29 04:03:12 +02:00
setup_flashable() {
2018-08-02 22:25:00 +02:00
$BOOTMODE && return
# Preserve environment varibles
OLD_PATH=$PATH
setup_bb
2018-07-07 11:48:05 +02:00
if [ -z $OUTFD ] || readlink /proc/$$/fd/$OUTFD | grep -q /tmp; then
# We will have to manually find out OUTFD
2018-07-07 11:48:05 +02:00
for FD in `ls /proc/$$/fd`; do
if readlink /proc/$$/fd/$FD | grep -q pipe; then
if ps | grep -v grep | grep -q " 3 $FD "; then
2017-07-09 18:17:34 +02:00
OUTFD=$FD
break
fi
fi
done
fi
}
2019-02-11 23:14:07 +01:00
setup_bb() {
if [ -x $MAGISKTMP/busybox/busybox ]; then
# Make sure this path is in the front
echo $PATH | grep -q "^$MAGISKTMP/busybox" || export PATH=$MAGISKTMP/busybox:$PATH
elif [ -x $TMPDIR/bin/busybox ]; then
# Make sure this path is in the front
echo $PATH | grep -q "^$TMPDIR/bin" || export PATH=$TMPDIR/bin:$PATH
else
# Construct the PATH
mkdir -p $TMPDIR/bin
ln -s $MAGISKBIN/busybox $TMPDIR/bin/busybox
$MAGISKBIN/busybox --install -s $TMPDIR/bin
export PATH=$TMPDIR/bin:$PATH
fi
2018-08-29 04:03:12 +02:00
}
2019-02-11 23:14:07 +01:00
boot_actions() {
if [ ! -d $MAGISKTMP/mirror/bin ]; then
mkdir -p $MAGISKTMP/mirror/bin
mount -o bind $MAGISKBIN $MAGISKTMP/mirror/bin
fi
MAGISKBIN=$MAGISKTMP/mirror/bin
setup_bb
2017-06-18 18:15:44 +02:00
}
2019-02-11 23:14:07 +01:00
recovery_actions() {
# TWRP bug fix
mount -o bind /dev/urandom /dev/random
# Temporarily block out all custom recovery binaries/libs
mv /sbin /sbin_tmp
# Unset library paths
OLD_LD_LIB=$LD_LIBRARY_PATH
OLD_LD_PRE=$LD_PRELOAD
unset LD_LIBRARY_PATH
unset LD_PRELOAD
}
recovery_cleanup() {
mv /sbin_tmp /sbin 2>/dev/null
[ -z $OLD_PATH ] || export PATH=$OLD_PATH
[ -z $OLD_LD_LIB ] || export LD_LIBRARY_PATH=$OLD_LD_LIB
[ -z $OLD_LD_PRE ] || export LD_PRELOAD=$OLD_LD_PRE
ui_print "- Unmounting partitions"
umount -l /system_root 2>/dev/null
umount -l /system 2>/dev/null
umount -l /vendor 2>/dev/null
umount -l /dev/random 2>/dev/null
2018-06-20 19:37:08 +02:00
}
2019-02-11 23:14:07 +01:00
#######################
# Installation Related
#######################
2018-06-20 19:37:08 +02:00
find_block() {
for BLOCK in "$@"; do
DEVICE=`find /dev/block -type l -iname $BLOCK | head -n 1` 2>/dev/null
if [ ! -z $DEVICE ]; then
readlink -f $DEVICE
return 0
fi
done
# Fallback by parsing sysfs uevents
2018-06-20 19:37:08 +02:00
for uevent in /sys/dev/block/*/uevent; do
local DEVNAME=`grep_prop DEVNAME $uevent`
local PARTNAME=`grep_prop PARTNAME $uevent`
2018-12-24 14:36:37 +01:00
for BLOCK in "$@"; do
if [ "`toupper $BLOCK`" = "`toupper $PARTNAME`" ]; then
2018-06-20 19:37:08 +02:00
echo /dev/block/$DEVNAME
return 0
fi
done
done
return 1
}
2017-09-12 22:07:25 +02:00
mount_partitions() {
# Check A/B slot
2018-06-20 19:37:08 +02:00
SLOT=`grep_cmdline androidboot.slot_suffix`
if [ -z $SLOT ]; then
SLOT=_`grep_cmdline androidboot.slot`
[ $SLOT = "_" ] && SLOT=
2017-11-10 18:33:50 +01:00
fi
2018-06-20 19:37:08 +02:00
[ -z $SLOT ] || ui_print "- Current boot slot: $SLOT"
2018-01-01 09:46:28 +01:00
2017-09-12 22:07:25 +02:00
ui_print "- Mounting /system, /vendor"
2018-06-17 11:59:24 +02:00
[ -f /system/build.prop ] || is_mounted /system || mount -o ro /system 2>/dev/null
2017-09-12 22:07:25 +02:00
if ! is_mounted /system && ! [ -f /system/build.prop ]; then
2018-06-20 19:37:08 +02:00
SYSTEMBLOCK=`find_block system$SLOT`
mount -o ro $SYSTEMBLOCK /system
2017-09-12 22:07:25 +02:00
fi
2018-06-17 11:59:24 +02:00
[ -f /system/build.prop ] || is_mounted /system || abort "! Cannot mount /system"
grep -qE '/dev/root|/system_root' /proc/mounts && SYSTEM_ROOT=true || SYSTEM_ROOT=false
2018-06-17 11:59:24 +02:00
if [ -f /system/init ]; then
SYSTEM_ROOT=true
2017-09-12 22:07:25 +02:00
mkdir /system_root 2>/dev/null
mount --move /system /system_root
mount -o bind /system_root/system /system
fi
if [ -L /system/vendor ]; then
# Seperate /vendor partition
is_mounted /vendor || mount -o ro /vendor 2>/dev/null
if ! is_mounted /vendor; then
2018-06-20 19:37:08 +02:00
VENDORBLOCK=`find_block vendor$SLOT`
mount -o ro $VENDORBLOCK /vendor
2017-09-12 22:07:25 +02:00
fi
is_mounted /vendor || abort "! Cannot mount /vendor"
fi
}
get_flags() {
# override variables
getvar KEEPVERITY
getvar KEEPFORCEENCRYPT
2018-12-24 18:08:46 +01:00
getvar RECOVERYMODE
if [ -z $KEEPVERITY ]; then
if $SYSTEM_ROOT; then
KEEPVERITY=true
ui_print "- Using system_root_image, keep dm/avb-verity"
else
KEEPVERITY=false
fi
fi
if [ -z $KEEPFORCEENCRYPT ]; then
grep ' /data ' /proc/mounts | grep -q 'dm-' && FDE=true || FDE=false
[ -d /data/unencrypted ] && FBE=true || FBE=false
# No data access means unable to decrypt in recovery
if $FDE || $FBE || ! $DATA; then
KEEPFORCEENCRYPT=true
ui_print "- Encrypted data detected, keep forceencrypt"
else
KEEPFORCEENCRYPT=false
fi
fi
2018-12-24 18:08:46 +01:00
[ -z $RECOVERYMODE ] && RECOVERYMODE=false
}
2018-06-20 19:37:08 +02:00
find_boot_image() {
BOOTIMAGE=
if [ ! -z $SLOT ]; then
2018-12-24 14:36:37 +01:00
BOOTIMAGE=`find_block ramdisk$SLOT recovery_ramdisk$SLOT boot$SLOT`
2018-06-20 19:37:08 +02:00
else
2018-12-24 14:36:37 +01:00
BOOTIMAGE=`find_block ramdisk recovery_ramdisk boot boot_a kern-a android_boot kernel lnx bootimg`
2018-06-20 19:37:08 +02:00
fi
if [ -z $BOOTIMAGE ]; then
# Lets see what fstabs tells me
BOOTIMAGE=`grep -v '#' /etc/*fstab* | grep -E '/boot[^a-zA-Z]' | grep -oE '/dev/[a-zA-Z0-9_./-]*' | head -n 1`
fi
2018-06-20 19:37:08 +02:00
}
2018-08-10 12:59:14 +02:00
flash_image() {
# Make sure all blocks are writable
$MAGISKBIN/magisk --unlock-blocks 2>/dev/null
2017-09-26 14:21:43 +02:00
case "$1" in
2019-02-11 23:14:07 +01:00
*.gz) CMD1="$MAGISKBIN/magiskboot --decompress '$1' - 2>/dev/null";;
*) CMD1="cat '$1'";;
2017-09-26 14:21:43 +02:00
esac
2018-02-09 20:34:13 +01:00
if $BOOTSIGNED; then
2019-02-11 23:14:07 +01:00
CMD2="$BOOTSIGNER -sign"
2018-08-10 12:59:14 +02:00
ui_print "- Sign image with test keys"
2018-02-09 20:34:13 +01:00
else
2019-02-11 23:14:07 +01:00
CMD2="cat -"
2018-08-10 12:59:14 +02:00
fi
if [ -b "$2" ]; then
local s_size=`stat -c '%s' "$1"`
local t_size=`blockdev --getsize64 "$2"`
[ $s_size -gt $t_size ] && return 1
2019-02-11 23:14:07 +01:00
eval $CMD1 | eval $CMD2 | cat - /dev/zero > "$2" 2>/dev/null
2018-08-10 12:59:14 +02:00
else
ui_print "- Not block device, storing image"
2019-02-11 23:14:07 +01:00
eval $CMD1 | eval $CMD2 > "$2" 2>/dev/null
2018-02-09 20:34:13 +01:00
fi
return 0
2017-09-06 10:13:23 +02:00
}
2017-11-10 18:33:50 +01:00
find_dtbo_image() {
2018-06-20 19:37:08 +02:00
DTBOIMAGE=`find_block dtbo$SLOT`
2017-11-10 18:33:50 +01:00
}
patch_dtbo_image() {
if [ ! -z $DTBOIMAGE ]; then
if $MAGISKBIN/magiskboot --dtb-test $DTBOIMAGE; then
2018-07-04 17:46:16 +02:00
ui_print "- Backing up stock DTBO image"
$MAGISKBIN/magiskboot --compress $DTBOIMAGE $MAGISKBIN/stock_dtbo.img.gz
2018-07-04 17:46:16 +02:00
ui_print "- Patching DTBO to remove avb-verity"
$MAGISKBIN/magiskboot --dtb-patch $DTBOIMAGE
return 0
2017-11-10 18:33:50 +01:00
fi
fi
return 1
2017-11-10 18:33:50 +01:00
}
2017-09-06 10:13:23 +02:00
sign_chromeos() {
2017-10-07 16:08:10 +02:00
ui_print "- Signing ChromeOS boot image"
2017-09-06 10:13:23 +02:00
2017-10-07 16:08:10 +02:00
echo > empty
./chromeos/futility vbutil_kernel --pack new-boot.img.signed \
2017-09-06 10:13:23 +02:00
--keyblock ./chromeos/kernel.keyblock --signprivate ./chromeos/kernel_data_key.vbprivk \
--version 1 --vmlinuz new-boot.img --config empty --arch arm --bootloader empty --flags 0x1
rm -f empty new-boot.img
mv new-boot.img.signed new-boot.img
}
2017-06-18 18:15:44 +02:00
remove_system_su() {
if [ -f /system/bin/su -o -f /system/xbin/su ] && [ ! -f /su/bin/su ]; then
2018-08-29 04:03:12 +02:00
ui_print "- Removing system installed root"
2017-06-18 18:15:44 +02:00
mount -o rw,remount /system
# SuperSU
if [ -e /system/bin/.ext/.su ]; then
mv -f /system/bin/app_process32_original /system/bin/app_process32 2>/dev/null
mv -f /system/bin/app_process64_original /system/bin/app_process64 2>/dev/null
mv -f /system/bin/install-recovery_original.sh /system/bin/install-recovery.sh 2>/dev/null
cd /system/bin
if [ -e app_process64 ]; then
ln -sf app_process64 app_process
else
ln -sf app_process32 app_process
fi
fi
rm -rf /system/.pin /system/bin/.ext /system/etc/.installed_su_daemon /system/etc/.has_su_daemon \
/system/xbin/daemonsu /system/xbin/su /system/xbin/sugote /system/xbin/sugote-mksh /system/xbin/supolicy \
/system/bin/app_process_init /system/bin/su /cache/su /system/lib/libsupol.so /system/lib64/libsupol.so \
/system/su.d /system/etc/install-recovery.sh /system/etc/init.d/99SuperSUDaemon /cache/install-recovery.sh \
/system/.supersu /cache/.supersu /data/.supersu \
/system/app/Superuser.apk /system/app/SuperSU /cache/Superuser.apk 2>/dev/null
fi
}
2017-07-02 15:36:09 +02:00
api_level_arch_detect() {
API=`grep_prop ro.build.version.sdk`
ABI=`grep_prop ro.product.cpu.abi | cut -c-3`
ABI2=`grep_prop ro.product.cpu.abi2 | cut -c-3`
ABILONG=`grep_prop ro.product.cpu.abi`
ARCH=arm
2018-04-22 08:13:27 +02:00
ARCH32=arm
2017-07-02 15:36:09 +02:00
IS64BIT=false
2018-04-22 08:13:27 +02:00
if [ "$ABI" = "x86" ]; then ARCH=x86; ARCH32=x86; fi;
if [ "$ABI2" = "x86" ]; then ARCH=x86; ARCH32=x86; fi;
if [ "$ABILONG" = "arm64-v8a" ]; then ARCH=arm64; ARCH32=arm; IS64BIT=true; fi;
if [ "$ABILONG" = "x86_64" ]; then ARCH=x64; ARCH32=x86; IS64BIT=true; fi;
2017-07-02 15:36:09 +02:00
}
2018-06-26 16:41:03 +02:00
check_data() {
DATA=false
DATA_DE=false
if grep ' /data ' /proc/mounts | grep -vq 'tmpfs'; then
# Test if data is writable
touch /data/.rw && rm /data/.rw && DATA=true
# Test if DE storage is writable
$DATA && [ -d /data/adb ] && touch /data/adb/.rw && rm /data/adb/.rw && DATA_DE=true
fi
2019-02-11 23:14:07 +01:00
$DATA && NVBASE=/data || NVBASE=/cache/data_adb
$DATA_DE && NVBASE=/data/adb
resolve_vars
2018-06-26 16:41:03 +02:00
}
2019-02-11 23:14:07 +01:00
find_manager_apk() {
APK=/data/adb/magisk.apk
[ -f $APK ] || APK=/data/magisk/magisk.apk
[ -f $APK ] || APK=/data/app/com.topjohnwu.magisk*/*.apk
if [ ! -f $APK ]; then
DBAPK=`magisk --sqlite "SELECT value FROM strings WHERE key='requester'" | cut -d= -f2`
[ -z "$DBAPK" ] || APK=/data/app/$DBAPK*/*.apk
2017-08-12 10:44:58 +02:00
fi
2017-07-02 15:36:09 +02:00
}
2019-02-11 23:14:07 +01:00
#################
# Module Related
#################
2017-07-09 18:17:34 +02:00
set_perm() {
2018-02-09 20:34:13 +01:00
chown $2:$3 $1 || return 1
chmod $4 $1 || return 1
CON=$5
[ -z $CON ] && CON=u:object_r:system_file:s0
chcon $CON $1 || return 1
2017-07-09 18:17:34 +02:00
}
set_perm_recursive() {
find $1 -type d 2>/dev/null | while read dir; do
set_perm $dir $2 $3 $4 $6
done
2017-07-30 21:03:52 +02:00
find $1 -type f -o -type l 2>/dev/null | while read file; do
2017-07-09 18:17:34 +02:00
set_perm $file $2 $3 $5 $6
done
}
mktouch() {
2017-07-30 21:03:52 +02:00
mkdir -p ${1%/*} 2>/dev/null
[ -z $2 ] && touch $1 || echo $2 > $1
2017-07-09 18:17:34 +02:00
chmod 644 $1
}
request_size_check() {
reqSizeM=`du -ms "$1" | cut -f1`
2017-07-09 18:17:34 +02:00
}
request_zip_size_check() {
reqSizeM=`unzip -l "$1" | tail -n 1 | awk '{ print int(($1 - 1) / 1048576 + 1) }'`
}
##################################
# Backwards Compatibile Functions
##################################
get_outfd() { setup_flashable; }
2017-07-09 18:17:34 +02:00
2017-12-25 20:23:58 +01:00
mount_magisk_img() {
$BOOTMODE && MODULE_BASE=modules_update || MODULE_BASE=modules
MODULEPATH=$NVBASE/$MODULE_BASE
mkdir -p $MODULEPATH 2>/dev/null
ln -s $MODULEPATH $MOUNTPATH
2017-12-25 20:23:58 +01:00
}
unmount_magisk_img() {
rm -f $MODULEPATH 2>/dev/null
2017-12-25 20:23:58 +01:00
}
2019-02-11 23:14:07 +01:00
#######
# main
#######
#MAGISK_VERSION_STUB
# Detect whether in boot mode
[ -z $BOOTMODE ] && BOOTMODE=false
$BOOTMODE || ps | grep zygote | grep -qv grep && BOOTMODE=true
$BOOTMODE || ps -A | grep zygote | grep -qv grep && BOOTMODE=true
# Presets
MAGISKTMP=/sbin/.magisk
NVBASE=/data/adb
# Bootsigner related stuff
BOOTSIGNERCLASS=a.a
BOOTSIGNER="/system/bin/dalvikvm -Xnodex2oat -Xnoimage-dex2oat -cp \$APK \$BOOTSIGNERCLASS"
BOOTSIGNED=false
resolve_vars